////////////////////////////////////////////////
//               Common variables
////////////////////////////////////////////////

char width=16;                  //⢮ ᨬ  ப LCD 
char height=2;                  //⢮ ப LCD 
char memh=0x3f;                 //訩  ᨬ쭮  
char meml=0xff;                 //訩  ᨬ쭮  

char nextl,nexth;
char posl,posh;
char menu_act,menu_pos;
char key;
char sleeping;

////////////////////////////////////////////////
//                  Pauses
////////////////////////////////////////////////

void wait(char p)               //প 
     {
     char i,j;
     for (j=0;j<p;j++)
         for (i=0;i<240;i++) nop();
     }

void wait1() {wait(10);}        //쪠 প 
void wait2() {wait(40);}        // প

////////////////////////////////////////////////
//               LCD procedures
////////////////////////////////////////////////

void PICtoLCD()                 //᪮䨣஢ 뢮  LCD
     {
     set_bit(STATUS,RP0);
     TRISB=0xe0;                // B  IIIOOOOO
     clear_bit(STATUS,RP0);
     }

void LCDtoPIC()                 //᪮䨣஢   LCD
     {
     set_bit(STATUS,RP0);
     TRISB=0xef;                // B  IIIOIIII
     clear_bit(STATUS,RP0);
     }

//RS=0 - , RS=1 - 
char readLCD(char rs)           //  LCD
     {
     char data;
     LCDtoPIC();
     if (rs) set_bit(PORTA,0); else clear_bit(PORTA,0);  //RS
     set_bit(PORTA,1);                                   //RW=1
     set_bit(PORTA,2);                                   //E=1
     data=PORTB<<4;
     clear_bit(PORTA,2);                                 //=0
     set_bit(PORTA,2);                                   //E=1
     data=data+(PORTB&0x0f);
     clear_bit(PORTA,2);                                 //=0
     PICtoLCD();
     return data;
     }

char busyLCD() {if (readLCD(0)&0x80) return 1; else return 0;} //஢ઠ  LCD

void writeLCD(char rs,char data)//뢮  LCD
     {
     while (busyLCD());
     if (rs) set_bit(PORTA,0); else clear_bit(PORTA,0);  //RS
     clear_bit(PORTA,1);                                 //RW=0
     PORTB=(data>>4)|0x10;
     set_bit(PORTA,2);                                   //E=1
     clear_bit(PORTA,2);                                 //=0
     PORTB=data|0x10;
     set_bit(PORTA,2);                                   //E=1
     clear_bit(PORTA,2);                                 //=0
     }

void outsymLCD(char sym) {writeLCD(1,sym);}   //뢮   LCD
void outcomLCD(char cmd) {writeLCD(0,cmd);}   //뢮   LCD
void clearLCD()   {outcomLCD(0x01);}          //⪠ LCD
//void scrollLCDr() {outcomLCD(0x1c);}        //ப⪠ LCD ࠢ
void scrollLCDl() {outcomLCD(0x18);}          //ப⪠ LCD 
void cursorposLCD(char pos) {outcomLCD(0x80+pos);} //樮஢  LCD 
//controlLCD  0x08+param (00001|display|cursor|blink)
//modesetLCD  0x04+param (000001|direction|scroll)

////////////////////////////////////////////////
//               INIT procedures
////////////////////////////////////////////////

void InitPIC()                  //樠 ⮢ /뢮
     {
     set_bit(STATUS,RP0);
     TRISA=0x0;                 // A     OOOOO
     TRISB=0xe0;                // B  IIIOOOOO
     OPTION_REG=0x0;            //㫠  B 
     INTCON=0x88;               //GIE=1 RBIE=1
     clear_bit(STATUS,RP0);     
     PORTA=0x0;
     PORTB=0x0;
     }

void InitPeripheral()           //樠 ਨ
     {
     set_bit(PORTA,3);          // SCL
     set_bit(PORTA,4);          // SDA
     }

void InitLCD()                  //樠 LCD
     {
     while (busyLCD());         //,   
     outcomLCD(0x30);           //䨣
     outcomLCD(0x20);           //4- ⭮
     outcomLCD(0x28);           //
     outcomLCD(8+4);            //controlLCD
     outcomLCD(4+2);            //modesetLCD
     }

void Init()                     //樠
     {
     InitPIC();
     InitPeripheral();
     InitLCD();
     }

void power(char p_on)           //ࠢ ⠭ 0-몫祭, 1-祭
     {
     if (p_on) 
        {set_bit(PORTB,4);Init();} else 
        {PORTB=0;clear_bit(PORTA,0);clear_bit(PORTA,1);}
     }

////////////////////////////////////////////////
//            i2c EEPROM procedures
////////////////////////////////////////////////

char busyi2c()                  // I2C
     {
     char i;
     for (i=0;i<10;i++)
         if (!(PORTA&8)) return 1;
     return 0;
     }

void usei2c(char use)           ///᢮ I2C
     {
     if (use)
        {
        while (busyi2c());
        set_bit(STATUS,RP0);
        TRISA=0x0;                 // A     OOOOO
        clear_bit(STATUS,RP0);     
        }
     else
        {
        set_bit(STATUS,RP0);
        TRISA=0x18;                // A     IIOOO
        clear_bit(STATUS,RP0);     
        }
     }

void SCL(char d){if (d) set_bit(PORTA,3);else clear_bit(PORTA,3);} //뢮  SCL
void SDA(char d){if (d) set_bit(PORTA,4);else clear_bit(PORTA,4);} //뢮  SDA

void trisSDA(char out)             //䨣஢ SDA 1-室  0-室
     {
     set_bit(STATUS,RP0);
     if (out) clear_bit(TRISA,4); else set_bit(TRISA,4);
     clear_bit(STATUS,RP0);
     if (out) SDA(1);              //ਢ SDA  ⭮ ﭨ
     }

char inSDA() {if (PORTA&0x10) return 1; else return 0;}  // 室 SDA=in SCL=0

void start() {SCL(1);SDA(0);SCL(0);} // 室   SCL=1 SDA=1 SDA=out
void stop()  {SDA(0);SCL(1);SDA(1);} // 室   SCL=0 SDA=out

void puti2c(char data)             //뢮   I2C // 室 SCL=0
     {
     char i;
     for (i=0;i<8;i++)
         {
         if (data&0x80) SDA(1);else SDA(0);
         SCL(1);SCL(0);
         data<<=1;
         }  
     trisSDA(0);
     SCL(1);
//     error=inSDA();
     SCL(0);
     trisSDA(1);
     }                             // 室 SCL=0

char geti2c()                      //   I2C // 室 SCL=0
     {
     char data=0;
     char mask=0x80;
     trisSDA(0);                   //input
     char i;
     for (i=0;i<8;i++)
         {
         SCL(1);
         if (inSDA()) data=data+mask;
         mask>>=1;
         SCL(0);
         }
     SCL(1);
//     error=inSDA();
     SCL(0);
     trisSDA(1);                   //output
     return data;
     }                             // 室 SCL=0
/*
void putmem(char ah,char al,char data) // 室   SCL=1 SDA=1 SDA=out
     {
     start();
     puti2c(160);
     puti2c(ah);
     puti2c(al);
     puti2c(data);
     stop();
     }
*/
char getmem(char ah,char al)       //祭    // 室   SCL=1 SDA=1 SDA=out
     {
     char data;
     start();
     puti2c(160);
     puti2c(ah);
     puti2c(al);
     start();
     puti2c(161);
     data=geti2c();
     stop();
     return data;
     }

////////////////////////////////////////////////
//                 Services
////////////////////////////////////////////////

void Intro()                       //⠢
     {
     cursorposLCD(16);
     outsymLCD('-');
     outsymLCD('=');
     outsymLCD(' ');
     outsymLCD('E');
     outsymLCD('-');
     outsymLCD('B');
     outsymLCD('o');
     outsymLCD('o');
     outsymLCD('k');
     outsymLCD(' ');
     outsymLCD('=');
     outsymLCD('-');
     char i;
     for (i=1;i<33;i++)
         {
         scrollLCDl();
         wait2();
         }
     }
     
/*
void outeeprom(char p)
     {
     char i;
     for (i=p;i<p+16;i++)
         { 
         EEADR=i;
         set_bit(EECON1,RD);
         outsymLCD(EEDATA);
         }      
     }
*/

char scankey()                     // 
     {
     if (!(PORTB&0x80)) return 1;
     if (!(PORTB&0x40)) return 2;
     if (!(PORTB&0x20)) return 3;
     return 0;
     }

char tmph,tmpl;

void inctmp() {if ((tmpl==meml)&&(tmph==memh)) return;if (tmpl==0xff) {tmpl++;tmph++;} else tmpl++;}    
void dectmp() {if ((tmpl==0)&&(tmph==0)) return;if (tmpl==0) {tmpl--;tmph--;} else tmpl--;}    

void outscr()   //뢮 ࠭, 稭  posh,posl  । ६ nexth  nextl
     {
     char r,x,y;
     clearLCD();
     tmph=posh;tmpl=posl;
     usei2c(1);     
     for (y=0;y<height;y++)
         {
         if (y==1) cursorposLCD(0x40);
         for (x=0;x<width;x++)
             {
             r=getmem(tmph,tmpl);
             if (r==0xd) {inctmp();inctmp();break;}
             outsymLCD(r);
             inctmp();         
             }
         }
     nexth=tmph;nextl=tmpl;
     usei2c(0);     
     }

void prevpos()  //। 樨  ஫ 
     {
     char i,y,r;
     y=0;
     tmph=posh;tmpl=posl;
     usei2c(1);     
     for (i=0;i<32;i++)
         {    
         dectmp();
         r=getmem(tmph,tmpl);
         if ((i==15)||(i==31)||(r==0xa)) y++;
         if (y==height) break;
         if (r==0xa) dectmp();
         }
     if (r==0xa) inctmp();
     usei2c(0);
     posh=tmph;posl=tmpl;
     }

void outhex(char v) {v=v&0xf;if (v>9) outsymLCD(v+55);else outsymLCD(v+48);}
void menu()     //뢮 
     {
     clearLCD();
     outcomLCD(8+7);
     char i;
     outsymLCD('R');
     outsymLCD(' ');     
     outsymLCD('H');
     outsymLCD(' ');     
     outsymLCD('E');
     outsymLCD(' ');     
     outsymLCD('S');
     cursorposLCD(12);     
     outhex(posh>>4);
     outhex(posh);     
     outhex(posl>>4);     
     outhex(posl);     
     menu_pos=0;
     cursorposLCD(0);     
     }
     
////////////////////////////////////////////////
//                Interrupt   
////////////////////////////////////////////////
void interrupt()   //ࠡ稪 뢠
     {
nextkey:
     key=scankey();
     if (key)
        {
        if (sleeping==1) {sleeping=2;goto exit;}        
        if (menu_act)
           {
           switch (key)
                  {
                  case 1:if (menu_pos>0) menu_pos=menu_pos-2;cursorposLCD(menu_pos);wait2();break;
                  case 2:if (menu_pos<6) menu_pos=menu_pos+2;cursorposLCD(menu_pos);wait2();break;
                  case 3:switch (menu_pos)
                                {
                                case 2:posh=0;posl=0;break;
                                case 4:posh=memh;posl=meml-32;break;
                                case 6:sleeping=1;break;
                                }
                         outcomLCD(8+4);       
                         outscr();wait1();
                         menu_act=0;
                         break;
                  }
           }
        else
           {
           switch (key)
                  {
                  case 1:prevpos();break;
                  case 2:posh=nexth;posl=nextl;break;
                  case 3:menu_act=1;menu();wait1();goto exit;
                  }
           outscr();wait1();
           }
        goto nextkey;
        }
exit:
     clear_bit(INTCON,RBIF);
     }

////////////////////////////////////////////////
//                   MAIN
////////////////////////////////////////////////

void main()
     {
     power(1);
     Intro();
     nextl=0;nexth=0;
     posl=0;posh=0;
     menu_act=1;
     sleeping=0;
     menu();
     
     for (;;) 
         {
         switch (sleeping)
                {
                case 0:break;
                case 1:power(0);break;
                case 2:power(1);sleeping=0;outscr();break;
                }
         sleep();
         }
     }
     
     